VERSION 4.00
Begin VB.Form FBrowsePictures 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Browse Picture Files"
   ClientHeight    =   4185
   ClientLeft      =   1245
   ClientTop       =   1695
   ClientWidth     =   8220
   Height          =   4590
   Left            =   1185
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MousePointer    =   13  'Arrow and Hourglass
   ScaleHeight     =   4185
   ScaleWidth      =   8220
   Top             =   1350
   Width           =   8340
   Begin VB.ComboBox cboPicType 
      Height          =   300
      Left            =   180
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   3630
      Width           =   2490
   End
   Begin VB.TextBox txtPicType 
      BorderStyle     =   0  'None
      Height          =   228
      Left            =   210
      TabIndex        =   3
      Text            =   "*.bmp;*.wmf;*.ico;*.dib "
      Top             =   555
      Width           =   2448
   End
   Begin VB.FileListBox filPic 
      Height          =   1785
      Left            =   180
      TabIndex        =   2
      Top             =   930
      Width           =   2505
   End
   Begin VB.DirListBox dirPic 
      Height          =   2055
      Left            =   2895
      TabIndex        =   1
      Top             =   945
      Width           =   2415
   End
   Begin VB.DriveListBox drvPic 
      Height          =   315
      Left            =   2865
      TabIndex        =   0
      Top             =   3630
      Width           =   2490
   End
   Begin ComctlLib.Toolbar bar 
      Align           =   1  'Align Top
      Height          =   390
      Left            =   0
      TabIndex        =   11
      Top             =   0
      Width           =   8220
      _Version        =   65536
      _ExtentX        =   14499
      _ExtentY        =   688
      _StockProps     =   96
      ImageList       =   "imlstBar"
      NumButtons      =   7
      i1              =   "browse.frx":0000
      i2              =   "browse.frx":01B3
      i3              =   "browse.frx":0366
      i4              =   "browse.frx":0519
      i5              =   "browse.frx":06CC
      i6              =   "browse.frx":086B
      i7              =   "browse.frx":0A2E
      AlignSet        =   -1  'True
   End
   Begin ComctlLib.ImageList imlstBar 
      Left            =   7665
      Top             =   3390
      _Version        =   65536
      _ExtentX        =   1005
      _ExtentY        =   1005
      _StockProps     =   1
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      NumImages       =   6
      i1              =   "browse.frx":0BFD
      i2              =   "browse.frx":0DB4
      i3              =   "browse.frx":0F6B
      i4              =   "browse.frx":1122
      i5              =   "browse.frx":12D9
      i6              =   "browse.frx":1490
   End
   Begin VB.Label lblDescribe 
      Height          =   1200
      Left            =   5520
      TabIndex        =   10
      Top             =   2790
      UseMnemonic     =   0   'False
      Width           =   1395
   End
   Begin VB.Image imgSIcon 
      Height          =   270
      Left            =   7590
      Top             =   2895
      Width           =   360
   End
   Begin VB.Image imgLIcon 
      Height          =   480
      Left            =   7020
      Top             =   2880
      Width           =   480
   End
   Begin VB.Image imgSound 
      Height          =   330
      Left            =   7245
      Picture         =   "browse.frx":1647
      Top             =   3555
      Visible         =   0   'False
      Width           =   360
   End
   Begin VB.Image imgPic 
      Height          =   1860
      Left            =   5520
      Top             =   900
      Width           =   2325
   End
   Begin VB.Label lbl 
      Caption         =   "File Name:"
      Height          =   228
      Index           =   1
      Left            =   192
      TabIndex        =   9
      Top             =   108
      Width           =   2436
   End
   Begin VB.Label lbl 
      Caption         =   "Directories:"
      Height          =   216
      Index           =   5
      Left            =   2916
      TabIndex        =   8
      Top             =   108
      Width           =   2436
   End
   Begin VB.Label lbl 
      Caption         =   "List Files of Type:"
      Height          =   315
      Index           =   4
      Left            =   150
      TabIndex        =   7
      Top             =   3300
      Width           =   2505
   End
   Begin VB.Label lbl 
      Caption         =   "Drives:"
      Height          =   315
      Index           =   3
      Left            =   2865
      TabIndex        =   6
      Top             =   3300
      Width           =   2430
   End
   Begin VB.Label lblPic 
      Height          =   270
      Left            =   2925
      TabIndex        =   5
      Top             =   555
      Width           =   4905
   End
End
Attribute VB_Name = "FBrowsePictures"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DEBUG.BAS

Private notify As New CFileNotify
Private hNotifyDir As Long
Private hNotifyFile As Long
Private hNotifyChange As Long

''@B InternalData
Private sInitDir As String
Private sFilePath As String     ' d:\path\
Private sFileName As String     ' base.ext
' Full file spec is sFilePath & sFileName
''@E InternalData
Private nsPicType As New Collection
Private dxPic As Integer, dyPic As Integer
Private ordMouse As Integer
Private afFilter As Long
Private fHasShell As Boolean

Private Sub Form_Load()
    BugMessage "Load"
    fHasShell = HasShell
    
    ' Restore directory and form state
    sInitDir = GetSetting(App.EXEName, "Options", "LastPath", CurDir$)
    RestoreForm Me
    'RestoreWindow Me.hWnd, Me.Caption
    ' Changing path triggers notification initialization
    hNotifyDir = -1
    hNotifyFile = -1
    hNotifyChange = -1
    dirPic.Path = sInitDir
    
    dxPic = imgPic.Width
    dyPic = imgPic.Height
    With cboPicType
        .AddItem "All Picture Files"
        nsPicType.Add "*.bmp;*.dib;*.ico;*.wmf;*.cur;*.wav"
        .AddItem "Bitmaps (*.BMP;*.DIB)"
        nsPicType.Add "*.bmp;*.dib"
        .AddItem "Metafiles (*.WMF)"
        nsPicType.Add "*.wmf"
        .AddItem "Icons (*.ICO)"
        nsPicType.Add "*.ico"
        .AddItem "Cursors (*.CUR;*.ICO)"
        nsPicType.Add "*.cur;*.ico"
        .AddItem "Waves (*.WAV)"
        nsPicType.Add "*.wav"
        .AddItem "All Files (*.*)"
        nsPicType.Add "*.*"
        .ListIndex = 0
    End With
    
    ' Save mouse pointer so we can restore
    ordMouse = MousePointer
    'dirPic_Change
    filPic_PathChange
    filPic_Click
End Sub

Private Sub Form_Unload(Cancel As Integer)
    BugMessage "Unload"
    notify.Disconnect hNotifyDir
    notify.Disconnect hNotifyFile
    notify.Disconnect hNotifyChange
    SaveSetting App.EXEName, "Options", "LastPath", dirPic.Path
    SaveForm Me
    'SaveWindow Me.hWnd, Me.Caption
End Sub

''@B FileChange
Public Sub FileChange(sDir As String, ordType As Long, _
                      fSubDir As Boolean)
    BugMessage "Directory: " & sDir & sCrLf
    BugMessage " (" & ordType & ":" & fSubDir & ")" & sCrLf
    Select Case ordType
    Case FILE_NOTIFY_CHANGE_DIR_NAME, FILE_NOTIFY_CHANGE_FILE_NAME
        Dim i As Integer
        ' Refresh drive, directory, and file lists
        i = filPic.ListIndex
        filPic.Refresh
        filPic.ListIndex = IIf(i, i - 1, i)
        dirPic.Refresh
        drvPic.Refresh
    Case FILE_NOTIFY_CHANGE_LAST_WRITE
        ' Refresh current picture in case it changed
        filPic_Click
    End Select
End Sub
''@E FileChange

''@B GetFileTitle
' FileTitle is read-only
Public Property Get FileTitle() As String
    FileTitle = sFileName  ' FileTitle is actually file name
End Property
''@E GetFileTitle

''@B GetLetFileName
Public Property Get FileName() As String
    If sFileName <> sEmpty Then
        FileName = sFilePath & sFileName
    ' Else (comments out because strings are empty by default)
    '    FileName = sEmpty
    End If
End Property

Public Property Let FileName(sFilePathA As String)
    sFilePath = sFilePathA
End Property
''@E GetLetFileName

''@B GetLetInitDir
Public Property Get InitDir() As String
    InitDir = sInitDir
End Property

Public Property Let InitDir(sInitDirA As String)
    sInitDir = sInitDirA
End Property
''@E GetLetInitDir

Public Property Let FilterType(afFilterA As Long)
    afFilter = afFilterA
End Property

Private Sub bar_ButtonClick(ByVal Button As Button)
    Dim sFullPath As String, sDst As String, errOK As Long
    Static sLastString As String
    Const sTitle = "Destination"
    sFullPath = sFilePath & filPic.FileName
    Select Case Button.Key
    Case "Delete"
        If Not FileDelete(sFullPath, FOF_NOCONFIRMATION) Then
            MsgBox "Can't delete file"
        End If
    Case "Copy"
        sDst = InputBox("Copy destination: ", sTitle, sLastString)
        If sDst = sEmpty Then Exit Sub
        If Not FileCopy(sFullPath, sDst) Then
            MsgBox "Can't copy file"
        Else
            sLastString = sDst
        End If
    Case "Move"
        sDst = InputBox("Move destination: ", sTitle, sLastString)
        If sDst = sEmpty Then Exit Sub
        If Not FileMove(sFullPath, sDst) Then
            MsgBox "Can't move file"
        Else
            sLastString = sDst
        End If
    Case "Rename"
        sDst = InputBox("New name: ", sTitle, sLastString)
        If sDst = sEmpty Then Exit Sub
        If Not FileRename(sFullPath, sFilePath & sDst) Then
            MsgBox "Can't rename file"
        Else
            sLastString = sDst
        End If
    Case "Connect"
        errOK = WNetConnectionDialog(Me.hWnd, RESOURCETYPE_DISK)
    Case "Disconnect"
        errOK = WNetDisconnectDialog(Me.hWnd, RESOURCETYPE_DISK)
    End Select
End Sub

Private Sub cboPicType_Change()
    txtPicType.Text = nsPicType(cboPicType.ListIndex + 1)
End Sub

Private Sub cboPicType_Click()
    txtPicType.Text = nsPicType(cboPicType.ListIndex + 1)
    filPic.Pattern = txtPicType.Text
End Sub

Private Sub cmdCancel_Click()
    sFileName = sEmpty
    Unload Me
End Sub

''@B cmdOK_Click
Private Sub cmdOK_Click()
    Unload Me
End Sub
''@E cmdOK_Click

''@B dirPic_Change
Private Sub dirPic_Change()
With notify
    filPic.Path = dirPic.Path
    If filPic.ListCount > 0 Then
        filPic.ListIndex = 0
    End If

    ' Watch whole drive for directory changes
    If hNotifyDir <> -1 Then .Disconnect hNotifyDir
    hNotifyDir = .Connect(Me, dirPic.Path, _
                          FILE_NOTIFY_CHANGE_DIR_NAME, False)
    ' Watch only current directory for file changes
    If hNotifyFile <> -1 Then .Disconnect hNotifyFile
    hNotifyFile = .Connect(Me, dirPic.Path, _
                           FILE_NOTIFY_CHANGE_FILE_NAME, False)
    ' Watch only current directory for file modifications
    If hNotifyChange <> -1 Then notify.Disconnect hNotifyChange
    hNotifyChange = .Connect(Me, dirPic.Path, _
                             FILE_NOTIFY_CHANGE_LAST_WRITE, False)
End With
End Sub
''@E dirPic_Change

Private Sub drvPic_Change()
    dirPic.Path = drvPic.Drive
End Sub

''@B filPic_PathChange
Private Sub filPic_PathChange()
    sFilePath = NormalizePath(filPic.Path)
    If filPic.ListCount > 0 Then filPic.ListIndex = 0
End Sub
''@E filPic_PathChange

''@B filPic_Click
Private Sub filPic_Click()
    sFileName = filPic.FileName
    UpdateFile sFilePath & sFileName
End Sub
''@E filPic_Click

Private Sub filPic_PatternChange()
    If filPic.ListCount > 0 Then
        filPic.ListIndex = 0
    End If
End Sub

Private Sub UpdateFile(sFile As String)
With imgPic
    MousePointer = ordMouse
    .Visible = False
    lblPic.Caption = sFile
    .Stretch = False
    Dim s As String
    imgSIcon.Picture = Nothing
    imgLIcon.Picture = Nothing
    If UCase$(Right$(sFile, 4)) = ".WAV" Then
        .Picture = imgSound.Picture
        s = s & "File length: " & FileLen(sFile)
        BugMessage s
        lblDescribe.Caption = s
        .Visible = True
        sndPlaySound sFile, 0
        Exit Sub
    Else
        On Error Resume Next
        .Picture = LoadPicture(sFile)
        If Err Then Exit Sub
        On Error GoTo 0
    End If
    Select Case .Picture.Type
    Case vbPicTypeIcon
        s = "Type: Icon" & sCrLf
        If UCase$(Right$(sFile, 4)) = ".CUR" Then
            On Error Resume Next
            Me.MousePointer = vbCustom
            Me.MouseIcon = .Picture
            On Error GoTo 0
            s = "Type: Cursor" & sCrLf
        Else
            If fHasShell Then
                imgSIcon.Picture = LoadPicture(sFile, vbIconSmall)
            End If
        End If
        imgLIcon.Picture = LoadPicture(sFile, vbIconDefault)
        
    Case vbPicTypeBitmap
        imgSIcon.Picture = Nothing
        imgLIcon.Picture = Nothing
        s = "Type: Bitmap" & sCrLf
        If ScaleX(.Picture.Width) > dxPic Then
            imgPic.Height = (dxPic / ScaleX(.Picture.Width)) * _
                            ScaleY(.Picture.Height)
            imgPic.Width = dxPic
        End If
        If ScaleY(.Picture.Height) > dyPic Then
            imgPic.Width = (dyPic / ScaleY(.Picture.Height)) * _
                            ScaleX(.Picture.Width)
            imgPic.Height = dyPic
            .Stretch = True
        End If
    Case vbPicTypeMetafile
        imgSIcon.Picture = Nothing
        imgLIcon.Picture = Nothing
        s = "Type: Metafile" & sCrLf
        imgPic.Width = dxPic
        imgPic.Height = dyPic
    End Select
    s = s & "Image: " & Int(ScaleX(imgPic.Width, vbTwips, vbPixels)) & _
            "x" & Int(ScaleX(imgPic.Height, vbTwips, vbPixels)) & sCrLf
    s = s & "Picture: " & Int(ScaleX(.Picture.Width, 8, vbPixels)) & _
            "x" & Int(ScaleY(.Picture.Height, 8, vbPixels)) & sCrLf
    s = s & "Handle: &H" & Hex(.Picture.Handle) & sCrLf
    If .Picture.Type = vbPicTypeBitmap Then
        s = s & "Palette: &H" & Hex(.Picture.hPal) & sCrLf
    End If
    If .Picture.Type = vbPicTypeIcon Then
        imgPic.Width = 128 * Screen.TwipsPerPixelX
        imgPic.Height = 128 * Screen.TwipsPerPixelY
    End If
    s = s & "File length: " & FileLen(sFile)
    BugMessage s
    lblDescribe.Caption = s
    .Stretch = True
    .Visible = True
End With
End Sub

