VERSION 4.00
Begin VB.Form FBugWizard 
   Caption         =   "Debug Wizard"
   ClientHeight    =   4470
   ClientLeft      =   1215
   ClientTop       =   1755
   ClientWidth     =   4350
   Height          =   4875
   Left            =   1155
   LinkTopic       =   "Form1"
   ScaleHeight     =   4470
   ScaleWidth      =   4350
   Top             =   1410
   Width           =   4470
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   492
      Left            =   120
      TabIndex        =   10
      Top             =   3840
      Width           =   2052
   End
   Begin VB.CommandButton cmdTrim 
      Caption         =   "Trim Assertions"
      Height          =   492
      Left            =   120
      TabIndex        =   9
      Top             =   3240
      Width           =   2052
   End
   Begin VB.FileListBox fileCur 
      Height          =   1005
      Left            =   2385
      Pattern         =   "*.bas;*.frm;*.cls"
      TabIndex        =   7
      Top             =   2160
      Width           =   1815
   End
   Begin VB.DirListBox dirCur 
      Height          =   930
      Left            =   2385
      TabIndex        =   6
      Top             =   1095
      Width           =   1815
   End
   Begin VB.DriveListBox drvCur 
      Height          =   315
      Left            =   2400
      TabIndex        =   5
      Top             =   600
      Width           =   1815
   End
   Begin VB.CommandButton cmdDisableProfile 
      Caption         =   "Disable Profile Procedures"
      Height          =   492
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   2052
   End
   Begin VB.CommandButton cmdEnableProfile 
      Caption         =   "Enable Profile Procedures"
      Height          =   492
      Left            =   120
      TabIndex        =   3
      Top             =   2040
      Width           =   2052
   End
   Begin VB.CommandButton cmdExpandAsserts 
      Caption         =   "Expand Assertions"
      Height          =   492
      Left            =   120
      TabIndex        =   2
      Top             =   2640
      Width           =   2052
   End
   Begin VB.CommandButton cmdEnableBug 
      Caption         =   "Enable Bug Procedures"
      Height          =   492
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   2052
   End
   Begin VB.CommandButton cmdDisableBug 
      Caption         =   "Disable Bug Procedures"
      Height          =   492
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   2052
   End
   Begin VB.Label lblFileCur 
      Height          =   315
      Left            =   2400
      TabIndex        =   8
      Top             =   210
      Width           =   1845
   End
End
Attribute VB_Name = "FBugWizard"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Public sFileCur As String

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdDisableBug_Click()
    HourGlass Me
    BugFilter sFileCur, ordDisableBug
    HourGlass Me
End Sub

Private Sub cmdDisableProfile_Click()
    HourGlass Me
    BugFilter sFileCur, ordDisableProfile
    HourGlass Me
End Sub

''@B cmdEnableBug
Private Sub cmdEnableBug_Click()
    HourGlass Me
    BugFilter sFileCur, ordEnableBug
    HourGlass Me
End Sub
''@E cmdEnableBug

Private Sub cmdEnableProfile_Click()
    HourGlass Me
    BugFilter sFileCur, ordEnableProfile
    HourGlass Me
End Sub

Private Sub cmdExpandAsserts_Click()
    HourGlass Me
    BugFilter sFileCur, ordExpandAsserts
    HourGlass Me
End Sub

Private Sub cmdTrim_Click()
    HourGlass Me
    BugFilter sFileCur, ordTrimAsserts
    HourGlass Me
End Sub

Private Sub dirCur_Change()
    fileCur.Path = dirCur.Path
    If fileCur.ListCount > 0 Then
        fileCur.ListIndex = 0
    End If
End Sub

Private Sub drvCur_Change()
    dirCur.Path = drvCur.Drive
End Sub

Private Sub fileCur_Click()
    lblFileCur.Caption = fileCur.filename
    sFileCur = fileCur.Path
    If Right$(sFileCur, 1) <> "\" Then
        sFileCur = sFileCur & "\"
    End If
    sFileCur = sFileCur & fileCur.filename
    lblFileCur.Caption = sFileCur
End Sub

Private Sub Form_Load()
    If fileCur.ListCount > 0 Then
        fileCur.ListIndex = 0
    End If
End Sub
