/*
*   Visual Basic Callback Server Source
*
*   (c) Copyright Microsoft Corp. 1995 All Rights Reserved
*/ 

#ifndef __CBackGen_H__
#define __CBackGen_H__
#include "hostenv.h"
#include "BaseDisp.h"
#include "CallBack.h"

CLASS CCBGenerator : public CBaseIDispatch
{
public:
    static CCBGenerator FAR* Create(void);
    STDMETHOD(get_NewCallBack)(THIS_ VBCallBackType Type, VARIANT VBHandler, VARIANT Contained, CCallBack FAR* FAR* retVal);
	CCBGenerator();
	~CCBGenerator();
};
CLASS CCBGeneratorCF : public IClassFactory
{
public:
    static IClassFactory FAR* Create();

    // IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, void FAR* FAR* ppv);
    STDMETHOD_(ULONG, AddRef)(void);
    STDMETHOD_(ULONG, Release)(void);

    // IClassFactory methods
    STDMETHOD(CreateInstance)(IUnknown FAR* pUnkOuter, REFIID riid, void FAR* FAR* ppv);
    STDMETHOD(LockServer)(BOOL fLock);
    CCBGeneratorCF();
	virtual ~CCBGeneratorCF();
private:

    ULONG m_refs;
};

#endif
