Attribute VB_Name = "MCommonControl"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

' Declares, Constants, Types, and Helpers for Common Controls

' ====== IMAGE APIS ========

Type TImageInfo
    hbmImage As Long
    hbmMask  As Long
    Unused1  As Long
    Unused2  As Long
    xLeft    As Long
    yTop     As Long
    xRight   As Long
    yBottom  As Long
End Type

Declare Function ImageList_GetImageInfo Lib "COMCTL32" ( _
    ByVal himl As Long, ByVal i As Long, pImageInfo As TImageInfo) As Long

Function INDEXTOOVERLAYMASK(i As Long) As Long
    INDEXTOOVERLAYMASK = i * 256
End Function

' ImageList_ReplaceIcon(himl, -1, hicon)
Function ImageList_AddIcon(ByVal himl As Long, ByVal hIcon As Long) As Long
    ImageList_AddIcon = ImageList_ReplaceIcon(himl, -1, hIcon)
End Function

' ImageList_Remove(himl, -1)
Function ImageList_RemoveAll(ByVal himl As Long) As Long
    ImageList_RemoveAll = ImageList_Remove(himl, -1)
End Function

' ImageList_GetIcon(himl, i, 0)
Function ImageList_ExtractIcon(ByVal himl As Long, ByVal i As Long) As Long
    ImageList_ExtractIcon = ImageList_GetIcon(himl, i, 0)
End Function

' ImageList_LoadImage(hi, lpbmp, cx, cGrow, crMask, IMAGE_BITMAP, 0)
Function ImageList_LoadBitmap(ByVal hi As Long, ByVal lpbmp As String, _
    ByVal cx As Long, ByVal cGrow As Long, ByVal crMask As Long, _
    ByVal uType As Long, ByVal uFlags As Long) As Long
    ImageList_LoadBitmap = ImageList_LoadImage(hi, lpbmp, cx, cGrow, _
                                               crMask, IMAGE_BITMAP, 0)
End Function

''@B DrawImage
Sub DrawImage(imlst As Control, vIndex As Variant, hDC As Long, _
              x As Long, y As Long, Optional vDraw As Variant)
    If IsMissing(vDraw) Then vDraw = ILD_TRANSPARENT
    ImageList_Draw imlst.hImageList, _
                   imlst.ListImages(vIndex).Index - 1, hDC, _
                   x / Screen.TwipsPerPixelX, _
                   y / Screen.TwipsPerPixelY, vDraw
End Sub
''@E DrawImage

