VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NDrives"
Attribute VB_Creatable = True
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DRIVE.CLS

''@B Initialize
Private drives As New Collection
Const iAscA = 65

Private Sub Class_Initialize()
    BugMessage "Initialize NDrives collection"
    Dim i As Integer, af As Long, sRoot As String
    Dim rdrive As CDrive
    af = GetLogicalDrives()
    For i = 0 To 25
        If RShiftDWord(af, i) And 1 Then
            Set rdrive = New CDrive
            rdrive.Root = Chr$(i + iAscA) & ":\"
            drives.Add rdrive, rdrive.Root
        End If
    Next
End Sub
''@E Initialize

Private Sub Class_Terminate()
    BugMessage "Terminate DrivesCollection"
End Sub

''@B CountItem
Public Property Get Count() As Integer
    Count = drives.Count
End Property

Public Function item(v As Variant) As CDrive
    On Error Resume Next
    Set item = drives(v)
    If Err <> 0 Then
        Set item = Nothing
    End If
End Function
''@E CountItem

''@B Items
Public Property Get Items() As Collection
    Set Items = drives
End Property
''@E Items

''@B Refresh
Public Sub Refresh()
    Set drives = Nothing
    Class_Initialize
End Sub
''@E Refresh

' Handy for refreshing local and/or remote, but not floppy
Public Sub RefreshSome(iFirst As Integer)
    Dim i As Integer, af As Long, sRoot As String
    Dim rdrive As CDrive
    ' Remove old ones
    Do While drives.Count > iFirst
        drives.Remove iFirst
    Loop
    ' Insert new
    af = GetLogicalDrives()
    For i = iFirst - 1 To 25
        If RShiftDWord(af, i) And 1 Then
            Set rdrive = New CDrive
            rdrive.Root = Chr$(i + iAscA) & ":\"
            drives.Add rdrive, rdrive.Root
        End If
    Next
    Class_Initialize
End Sub
