Attribute VB_Name = "MHardCore"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B GetScrollRange
#If Win32 Then
Declare Function GetScrollRange Lib "USER32" (ByVal hWnd As Long, _
    ByVal nBar As Long, lpMin As Long, lpMax As Long) As Long
#Else
Declare Function GetScrollRange Lib "USER" (ByVal hWnd As Integer, _
    ByVal nBar As Integer, lpMin As Integer, lpMax As Integer) As Integer
#End If
''@E GetScrollRange

#If Win32 Then
Declare Function VBGetObject Lib "GDI32" Alias "GetObjectA" ( _
    ByVal hObject As Long, ByVal nCount As Long, _
    lpvObject As Any) As Long
#Else
''@B VBGetObject
Declare Function VBGetObject Lib "GDI" Alias "GetObject" ( _
    ByVal hObject As Integer, ByVal nCount As Integer, _
    lpvObject As Any) As Integer
''@E VBGetObject
#End If

''@B WordFromStrB
Function WordFromStrB(sBuf As String, iOffset As Long) As Integer
    BugAssert (iOffset + 2) <= LenB(sBuf) - 1
    Dim dw As Long
    dw = AscB(MidB$(sBuf, iOffset + 2, 1)) * 256&
    dw = dw + AscB(MidB$(sBuf, iOffset + 1, 1))
    If dw And &H8000& Then
        WordFromStrB = &H8000 Or (dw And &H7FFF&)
    Else
        WordFromStrB = dw And &HFFFF&
    End If
End Function
''@E WordFromStrB
