VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CGetColor"
Attribute VB_Creatable = True
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private pb As Control
Private aColor(1 To 16, 1 To 3) As Long
Private iColor As Long
Private ix As Long, iy As Long, ordFillStyle As Integer

Private Sub Class_Initialize()
    ix = 1
    iy = 1
    ' Initialize color array
    aColor(1, 1) = &HFFFFFF
    aColor(1, 2) = &HC0C0C0
    aColor(1, 3) = &H808080
    aColor(2, 1) = &HE0E0E0
    aColor(2, 2) = &H404040
    aColor(2, 3) = &H0
    aColor(3, 1) = &HC0C0FF
    aColor(3, 2) = &H8080FF
    aColor(3, 3) = &HFF&
    aColor(4, 1) = &HC0E0FF
    aColor(4, 2) = &H80C0FF
    aColor(4, 3) = &H80FF&
    aColor(5, 1) = &HC0FFFF
    aColor(5, 2) = &H80FFFF
    aColor(5, 3) = &HFFFF&
    aColor(6, 1) = &HC0FFC0
    aColor(6, 2) = &H80FF80
    aColor(6, 3) = &HFF00&
    aColor(7, 1) = &HFFFFC0
    aColor(7, 2) = &HFFFF80
    aColor(7, 3) = &HFFFF00
    aColor(8, 1) = &HFFC0C0
    aColor(8, 2) = &HFF8080
    aColor(8, 3) = &HFF0000
    aColor(9, 1) = &HFFC0FF
    aColor(9, 2) = &HFF80FF
    aColor(9, 3) = &HFF00FF
    aColor(10, 1) = &HC0&
    aColor(10, 2) = &H80&
    aColor(10, 3) = &H40&
    aColor(11, 1) = &H40C0&
    aColor(11, 2) = &H4080&
    aColor(11, 3) = &H404080
    aColor(12, 1) = &HC0C0&
    aColor(12, 2) = &H8080&
    aColor(12, 3) = &H4040&
    aColor(13, 1) = &HC000&
    aColor(13, 2) = &H8000&
    aColor(13, 3) = &H4000&
    aColor(14, 1) = &HC0C000
    aColor(14, 2) = &H808000
    aColor(14, 3) = &H404000
    aColor(15, 1) = &HC00000
    aColor(15, 2) = &H800000
    aColor(15, 3) = &H400000
    aColor(16, 1) = &HC000C0
    aColor(16, 2) = &H800080
    aColor(16, 3) = &H400040
End Sub


Function Create(pbA As PictureBox) As Boolean
    Create = True
    On Error GoTo CreateFail
    Set pb = pbA
    ' Set the width and height exactly
    With pb
        .ScaleMode = vbPixels
        .Width = .ScaleX(275, vbPixels, vbTwips)
        .Height = .ScaleX(54, vbPixels, vbTwips)
        GetColor_Paint
        DrawSelection
    End With
    Exit Function
    
CreateFail:         ' Shouldn't happen
    Create = False
End Function

Sub GetColor_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' Calculate the current position
    ix = ((x + 1) \ 17) + 1
    iy = ((y + 1) \ 17) + 1
    DrawSelection
End Sub

Sub GetColor_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    ordFillStyle = pb.FillStyle
    pb.FillStyle = 1 ' vbTransparent
    pb.Line (((ix - 1) * 17) + 1, ((iy - 1) * 17) + 1)-Step(15, 15), vbBlack, B
    pb.Line (((ix - 1) * 17), ((iy - 1) * 17))-Step(16, 16), &H808080, B
    pb.FillStyle = ordFillStyle
    iColor = aColor(ix, iy)
End Sub

Property Get Color() As Long
    Color = iColor
End Property

Property Let Color(iColor As Long)
    Dim i As Long, ixT As Long, iyT As Long
    For ix = 1 To 16
        For iy = 1 To 3
            If aColor(ix, iy) = iColor Then Exit Property
        Next
    Next
End Property

Sub GetColor_Paint()
    Dim x As Long, y As Long, ix As Long, iy As Long
    ' Draw the colors in their boxes
    x = 1
    pb.FillStyle = vbSolid
    For ix = 1 To 16
        y = 1
        For iy = 1 To 3
            pb.FillColor = aColor(ix, iy)
            pb.Line (((ix - 1) * 17) + 1, ((iy - 1) * 17) + 1)-Step(15, 15), , B
            y = y + 17
        Next
        x = x + 17
    Next
End Sub

Sub DrawSelection()
    ' Box the selection
    ordFillStyle = pb.FillStyle
    pb.FillStyle = 1 ' vbTransparent
    pb.Line (((ix - 1) * 17) + 1, ((iy - 1) * 17) + 1)-Step(15, 15), vbBlack, B
    pb.Line (((ix - 1) * 17), ((iy - 1) * 17))-Step(16, 16), vbWhite, B
    pb.FillStyle = ordFillStyle
End Sub
