VERSION 4.00
Begin VB.Form FGetColor 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   1125
   ClientLeft      =   4635
   ClientTop       =   2805
   ClientWidth     =   4260
   ControlBox      =   0   'False
   Height          =   1530
   Left            =   4575
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   75
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   284
   Top             =   2460
   Width           =   4380
   Begin VB.Image imgPalette 
      Height          =   795
      Left            =   675
      Picture         =   "GETCOLOR.frx":0000
      Top             =   1935
      Width           =   4095
   End
End
Attribute VB_Name = "FGetColor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private aColor(1 To 16, 1 To 3) As Long
Private iColor As Long
Private ix As Long, iy As Long, ordFillStyle As Integer

    ''@B Form_Initialize
Private Sub Form_Initialize()
    ix = 1
    iy = 1
    ' Initialize color array
    aColor(1, 1) = &HFFFFFF
    aColor(1, 2) = &HC0C0C0
    aColor(1, 3) = &H808080
    aColor(2, 1) = &HE0E0E0
    ''@E Form_Initialize...
    aColor(2, 2) = &H404040
    aColor(2, 3) = &H0
    aColor(3, 1) = &HC0C0FF
    aColor(3, 2) = &H8080FF
    aColor(3, 3) = &HFF&
    aColor(4, 1) = &HC0E0FF
    aColor(4, 2) = &H80C0FF
    aColor(4, 3) = &H80FF&
    aColor(5, 1) = &HC0FFFF
    aColor(5, 2) = &H80FFFF
    aColor(5, 3) = &HFFFF&
    aColor(6, 1) = &HC0FFC0
    aColor(6, 2) = &H80FF80
    aColor(6, 3) = &HFF00&
    aColor(7, 1) = &HFFFFC0
    aColor(7, 2) = &HFFFF80
    aColor(7, 3) = &HFFFF00
    aColor(8, 1) = &HFFC0C0
    aColor(8, 2) = &HFF8080
    aColor(8, 3) = &HFF0000
    aColor(9, 1) = &HFFC0FF
    aColor(9, 2) = &HFF80FF
    aColor(9, 3) = &HFF00FF
    aColor(10, 1) = &HC0&
    aColor(10, 2) = &H80&
    aColor(10, 3) = &H40&
    aColor(11, 1) = &H40C0&
    aColor(11, 2) = &H4080&
    aColor(11, 3) = &H404080
    aColor(12, 1) = &HC0C0&
    aColor(12, 2) = &H8080&
    aColor(12, 3) = &H4040&
    aColor(13, 1) = &HC000&
    aColor(13, 2) = &H8000&
    aColor(13, 3) = &H4000&
    aColor(14, 1) = &HC0C000
    aColor(14, 2) = &H808000
    aColor(14, 3) = &H404000
    aColor(15, 1) = &HC00000
    aColor(15, 2) = &H800000
    aColor(15, 3) = &H400000
    aColor(16, 1) = &HC000C0
    aColor(16, 2) = &H800080
    aColor(16, 3) = &H400040
End Sub


Private Sub Form_Load()
    ' Set the form width and height exactly
    Width = ScaleX(275, vbPixels, vbTwips)
    Height = ScaleX(54, vbPixels, vbTwips)
End Sub

''@B Form_Paint
Private Sub Form_Paint()
    Dim x As Long, y As Long, ix As Long, iy As Long
    ' Draw colors in their boxes
    x = 1
    FillStyle = vbSolid
    For ix = 1 To 16
        y = 1
        For iy = 1 To 3
            FillColor = aColor(ix, iy)
            Line (((ix - 1) * 17) + 1, _
                  ((iy - 1) * 17) + 1)-Step(15, 15), , B
            y = y + 17
        Next
        x = x + 17
    Next
End Sub
''@E Form_Paint

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' Calculate the current position
    ix = ((x + 1) \ 17) + 1
    iy = ((y + 1) \ 17) + 1
    DrawSelection
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    ordFillStyle = FillStyle
    FillStyle = 1 ' vbTransparent
    Line (((ix - 1) * 17) + 1, ((iy - 1) * 17) + 1)-Step(15, 15), vbBlack, B
    Line (((ix - 1) * 17), ((iy - 1) * 17))-Step(16, 16), &H808080, B
    FillStyle = ordFillStyle
    iColor = aColor(ix, iy)
    Unload Me
End Sub

Property Get Color() As Long
    Color = iColor
End Property

Property Let Color(iColor As Long)
    Dim i As Long, ixT As Long, iyT As Long
    For ix = 1 To 16
        For iy = 1 To 3
            If aColor(ix, iy) = iColor Then Exit Property
        Next
    Next
End Property

Sub DrawSelection()
    ' Box the selection
    ordFillStyle = FillStyle
    FillStyle = 1 ' vbTransparent
    Line (((ix - 1) * 17) + 1, ((iy - 1) * 17) + 1)-Step(15, 15), vbBlack, B
    Line (((ix - 1) * 17), ((iy - 1) * 17))-Step(16, 16), vbWhite, B
    FillStyle = ordFillStyle
End Sub
