VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CItemHandler"
Attribute VB_Creatable = False
Attribute VB_Exposed = True
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses ADDINMAN.CLS MNUITEMS.CLS

''@B Create
Private ritems As NMenuItems
Private rman As CAddInManager
Private rap As Application
Private rline As MenuLine
Private sName As String
Private hConnect As Long

Function Create(ritemsA As NMenuItems, _
                sCaption As String, sCmd As String, _
                Optional vChecked As Variant) As Boolean
    On Error GoTo CreateFail
    Set ritems = ritemsA
    Set rman = ritems.Manager
    Set rap = ritems.Application
    ' Add menu text to VBIDE Add-Ins menu
    Set rline = rap.AddInMenu.MenuItems.Add(sCaption)
    ' Connect menu line
    hConnect = rline.ConnectEvents(Me)
    sName = sCmd
    Caption = sCaption
    If Not IsMissing(vChecked) Then Checked = vChecked
    Create = True
CreateFail:
End Function
''@E Create

''@B Destroy
Sub Destroy()
    On Error Resume Next
    ' Disconnect event
    rline.DisconnectEvents hConnect
    ' Remove from parent menu
    rline.Parent.Remove rline
End Sub
''@E Destroy

Property Get Name() As String
    Name = sName
End Property

Property Get Caption() As String
    Caption = rline.Caption
End Property

Property Let Caption(sCaptionA As String)
    rline.Caption = sCaptionA
End Property

Property Get Checked() As Boolean
    Checked = rline.Checked
End Property

Property Let Checked(f As Boolean)
    rline.Checked = f
End Property

Property Get Enabled() As Boolean
    Enabled = rline.Enabled
End Property

Property Let Enabled(f As Boolean)
    rline.Enabled = f
End Property

Property Get Application() As Application
    Set Application = rap
End Property

Property Get Parent() As CAddInManager
    Set Parent = ritems
End Property

Property Get Manager() As CAddInManager
    Set Manager = rman
End Property

''@B AfterClick
Public Sub AfterClick()
    With rman.Commands
        .Execute .Item(sName)
    End With
End Sub
''@E AfterClick



