VERSION 4.00
Begin VB.Form FTestBezier 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Bezier Curves"
   ClientHeight    =   5385
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   4410
   DrawStyle       =   2  'Dot
   Height          =   5790
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   5385
   ScaleWidth      =   4410
   Top             =   1170
   Width           =   4530
End
Attribute VB_Name = "FTestBezier"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

''@B apt
Private apt(0 To 3) As TPoint
''@E apt

Private Sub Form_Load()
    Show
    InitBezier ScaleWidth, ScaleHeight
    DrawBezier
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button Then MoveBezier Button, x, y
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    MoveBezier Button, x, y
End Sub


''@B InitBezier
Sub InitBezier(cxClient As Long, cyClient As Long)
    apt(0).x = ScaleX(cxClient / 2, vbTwips, vbPixels)
    apt(0).y = ScaleY(cyClient / 10, vbTwips, vbPixels)
    apt(1).x = ScaleX(cxClient / 4, vbTwips, vbPixels)
    apt(1).y = ScaleY(cyClient / 2, vbTwips, vbPixels)
    apt(2).x = ScaleX(3 * cxClient / 4, vbTwips, vbPixels)
    apt(2).y = ScaleY(cyClient / 2, vbTwips, vbPixels)
    apt(3).x = ScaleX(cxClient / 2, vbTwips, vbPixels)
    apt(3).y = ScaleY(9 * cyClient / 10, vbTwips, vbPixels)
    ForeColor = vbRed
End Sub
''@E InitBezier

''@B DrawBezier
Sub DrawBezier()
    DrawStyle = vbSolid
    PolyBezier hDC, apt(0), 4
    DrawStyle = vbDot
    MoveTo hDC, apt(0).x, apt(0).y
    LineTo hDC, apt(1).x, apt(1).y
    MoveTo hDC, apt(2).x, apt(2).y
    LineTo hDC, apt(3).x, apt(3).y
End Sub
''@E DrawBezier

Sub MoveBezier(ordButton As Integer, cx As Single, cy As Single)
    ForeColor = BackColor
    DrawBezier
    If ordButton = vbLeftButton Then
        apt(1).x = ScaleX(cx, vbTwips, vbPixels)
        apt(1).y = ScaleY(cy, vbTwips, vbPixels)
    End If
    If ordButton = vbRightButton Then
        apt(2).x = ScaleX(cx, vbTwips, vbPixels)
        apt(2).y = ScaleY(cy, vbTwips, vbPixels)
    End If
    ForeColor = vbRed
    DrawBezier
End Sub


