VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CVideo"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B VideoClass
Private hdcScreen ' As SysInt

Private Sub Class_Initialize()
    hdcScreen = GetDC(hNull)
End Sub

Private Sub Class_Terminate()
    Call ReleaseDC(hNull, hdcScreen)
End Sub

Private Function GetCaps(iCode As Long) As Long
    GetCaps = GetDeviceCaps(hdcScreen, iCode)
End Function

Property Get BitsPerPixel() As Long
    BitsPerPixel = GetCaps(BITSPIXEL)
End Property

Property Get ColorPlanes() As Long
    ColorPlanes = GetCaps(PLANES)
End Property
''@E VideoClass

Property Get Technology() As Long
    Technology = GetCaps(Technology)
End Property

Property Get XPixels() As Long
    XPixels = GetCaps(HORZRES)
End Property

Property Get YPixels() As Long
    YPixels = GetCaps(VERTRES)
End Property

Property Get BrushCount() As Long
    BrushCount = GetCaps(NUMBRUSHES)
End Property

Property Get PenCount() As Long
    PenCount = GetCaps(NUMPENS)
End Property

Property Get FontCount() As Long
    FontCount = GetCaps(NUMFONTS)
End Property

Property Get ColorCount() As Long
    ColorCount = GetCaps(NUMCOLORS)
End Property

Property Get XAspect() As Long
    XAspect = GetCaps(ASPECTX)
End Property

Property Get YAspect() As Long
    YAspect = GetCaps(ASPECTY)
End Property

Property Get XYAspect() As Long
    XYAspect = GetCaps(ASPECTXY)
End Property

Property Get PaletteSize() As Long
    PaletteSize = 0&
    If RasterCapability And RC_PALETTE Then
        PaletteSize = GetCaps(SIZEPALETTE)
    End If
End Property

Property Get RasterCapability() As Long
    RasterCapability = GetCaps(RASTERCAPS)
End Property

Property Get CurveCapability() As Long
    CurveCapability = GetCaps(CURVECAPS)
End Property

Property Get LineCapability() As Long
    LineCapability = GetCaps(LINECAPS)
End Property

Property Get PolygonCapability() As Long
    PolygonCapability = GetCaps(POLYGONALCAPS)
End Property

Property Get TextCapability() As Long
    TextCapability = GetCaps(TEXTCAPS)
End Property

Property Get TransparentBlt() As Boolean
    TransparentBlt = GetCaps(CAPS1) And C1_TRANSPARENT
End Property
